require 'rack'

module Rack
  class NoIE
    def initialize(app, options = {})
      @app = app
      @options = options
      @options[:redirect] ||= 'http://www.microsoft.com/windows/internet-explorer/default.aspx'
      @options[:minimum] ||= 7.0
      @options[:allow_path] ||= []
      @options[:deny_path] ||= [/.*/]
    end

    def call(env)
      @options[:allow_path].each do |path| 
              return @app.call(env)  if env['PATH_INFO'].match(path)
      end
      
      @options[:deny_path].each do |path| 
              return kick_it  if env['PATH_INFO'].match(path) and ie_found_in?(env)
      end
	    
      @app.call(env)    
    end

    private
    def ie_found_in?(env)
      if env['HTTP_USER_AGENT']
        is_ie?(env['HTTP_USER_AGENT']) and ie_version(env['HTTP_USER_AGENT']) < @options[:minimum] and @options[:redirect] != env['PATH_INFO']
      end
    end
    
    def is_ie?(ua_string)
      # We need at least one digit to be able to get the version, hence the \d
      ua_string.match(/MSIE \d/) ? true : false
    end
    
    def ie_version(ua_string)
      ua_string.match(/MSIE (\S+)/)[1].to_f
    end

    def kick_it
      [301, {'Location' => @options[:redirect]}, ['Fail browser is fail']]
    end
  end
end
